package ovm.polyd.test14;
import ovm.polyd.Descriptor;
import ovm.polyd.policy.*;
import java.lang.reflect.*;
import ovm.polyd.Missing;
import ovm.polyd.PolyD;

class Test
{
 public static void main(String[] s) {
  test1();
 }
 
 public static void indirect(Dance m,Person p) {
  m.skal(p);
 }
 
 public static void test1() {
  Person james=new Person("James");
  Person alice=new Person("Alice");
  Disco disco=new Disco("The Cavern");
  Park park=new Park("Central Park");
  Worker ellen=new Worker("Ellen");
  Workplace office=new Workplace("BMV");
  Factory acme=new Factory("ACME");
  Place someplace=new Place("somewhere");
  

  try {
  
  ComboA a=new ComboA();
  ComboB b=new ComboB();
  ComboC c=new ComboC("String");
  Method mt;
  Field f;
  
  Descriptor d1=new Descriptor(DanceAux1.class,new Class[] {ComboA.class,ComboB.class,ComboC.class});
  d1.setDispatching(MultiDisp.class);
  mt=DanceAux1.class.getMethod("dance",new Class[]{Person.class,Place.class});
  d1.setMethodAsClasses(mt,new Class[]{Person.class,null});
  mt=DanceAux1.class.getMethod("visit",new Class[]{Place.class});
  d1.setMethodAsClasses(mt,new Class[]{Place.class});
  f=ComboA.class.getField("super1");
  d1.setSelfField(f);
  f=ComboC.class.getField("aux1");
  d1.setSelfField(f);
  mt=ComboC.class.getMethod("lxp",new Class[]{String.class});
  d1.setMethodName(mt,"lxn");
  d1.register();
  
  DanceAux1 aux1=(DanceAux1)PolyD.buildFromDescriptor(DanceAux1.class,new Object[]{a,b,c});
  d1=null; //GC
  
  Descriptor d2=new Descriptor(DanceAux2.class,new Class[] {ComboA.class,ComboB.class,ComboC.class});
  d2.setDispatching(MultiDisp.class);
  mt=DanceAux2.class.getMethod("dance",new Class[]{Person.class,Place.class});
  d2.setMethodAsClasses(mt,new Class[]{null,Place.class});
  f=ComboC.class.getField("aux2");
  d2.setSelfField(f);
  mt=ComboC.class.getMethod("lxp",new Class[]{String.class});
  d2.setMethodName(mt,"lxn");
  d2.register();

  DanceAux2 aux2=(DanceAux2)PolyD.buildFromDescriptor(DanceAux2.class,new Object[]{a,b,c});
  d2=null; //GC  
  
  Descriptor d3=new Descriptor(Dance.class,new Class[] {ComboA.class,ComboB.class,ComboC.class});
  d3.setDispatching(MultiDisp.class);
//  d3.addInvocation(DebuggingInvocation.class);
  mt=Dance.class.getMethod("test",new Class[]{long.class,Place.class});
  d3.setMethodNullDefaults(mt,new Class[]{null,Place.class});
  mt=Dance.class.getMethod("visit",new Class[]{Place.class});
  d3.setMethodDispatching(mt,MultiDisp.class);
  mt=Dance.class.getMethod("lx",new Class[]{String.class});
  d3.setMethodName(mt,"lxn");
  mt=Dance.class.getMethod("quattro",new Class[]{String.class,char.class,Object.class,Place.class});
  d3.setMethodPreload(mt,new Class[][] {{String.class,char.class,Object.class,Place.class}});
  mt=Dance.class.getMethod("multi",new Class[]{Object.class,Object.class,Object.class,Object.class,Object.class});
  d3.setMethodNullDefaults(mt,new Class[]{null,null,Object.class,null,null});
  mt=Dance.class.getMethod("mate",new Class[]{Person.class});
  d3.setMethodPreload(mt,new Class[][]{{Person.class},{Worker.class}});
  mt=Dance.class.getMethod("nonSubsumpDance",new Class[]{Person.class,Place.class});
  d3.setMethodDispatching(mt,NonSubsump.class);
  d3.setMethodName(mt,"dance");
  d3.setMethodMissingHandling(mt,Missing.IGNORE);
  f=ComboC.class.getField("self");
  d3.setSelfField(f);
  mt=ComboC.class.getMethod("lxp",new Class[]{String.class});
  d3.setMethodName(mt,"lxn");
  d3.register();

  Dance m=(Dance)PolyD.buildFromDescriptor(Dance.class,new Object[]{a,b,c});
  d3=null; // GC

  m.concat("Power","Mac");
  m.dance(ellen,acme);
  m.dance(james,disco);
  m.dance(james,acme);
  m.dance(alice,disco);
  m.dance(alice,park);
  m.dance(ellen,park);
  m.dance(ellen,office);
  m.dance(james,office);
  
  m.checkA(james,james);
  m.checkB(james,james);
  
  m.test(5,park);
  m.tast(5,10);
  
  m.quirk("",3.0,park);
  m.nasty();
  m.visit(acme);
  m.visit(park);
  m.visit(disco);
  m.visit(someplace);

  m.quattro("s",'c',ellen,park);
  m.penta("s",4,"t",9,"z");

  Person p=ellen;
  
  indirect(m,p);
  
  m.covar(park);
  
  String dp="Dolly Parton";
  System.out.println("The length of the string \""+dp+"\" is "+m.len(dp));
  dp="Parton Dolly";
  System.out.println("The length of the string \""+dp+"\" is "+m.lx(dp));
  
  m.dance(m.mate(alice),office);

  m.test(6,acme);
  System.out.println("Adding method bodies from \"ComboD\"");
  
  Descriptor d3a=new Descriptor(Dance.class,new Class[] {ComboA.class,ComboB.class,ComboC.class,ComboD.class});
  d3a.setDispatching(MultiDisp.class);
//  d3.addInvocation(DebuggingInvocation.class);
  mt=Dance.class.getMethod("test",new Class[]{long.class,Place.class});
  d3a.setMethodNullDefaults(mt,new Class[]{null,Place.class});
  mt=Dance.class.getMethod("visit",new Class[]{Place.class});
  d3a.setMethodDispatching(mt,MultiDisp.class);
  mt=Dance.class.getMethod("lx",new Class[]{String.class});
  d3a.setMethodName(mt,"lxn");
  mt=Dance.class.getMethod("quattro",new Class[]{String.class,char.class,Object.class,Place.class});
  d3a.setMethodPreload(mt,new Class[][] {{String.class,char.class,Object.class,Place.class}});
  mt=Dance.class.getMethod("multi",new Class[]{Object.class,Object.class,Object.class,Object.class,Object.class});
  d3a.setMethodNullDefaults(mt,new Class[]{null,null,Object.class,null,null});
  mt=Dance.class.getMethod("mate",new Class[]{Person.class});
  d3a.setMethodPreload(mt,new Class[][]{{Person.class},{Worker.class}});
  mt=Dance.class.getMethod("nonSubsumpDance",new Class[]{Person.class,Place.class});
  d3a.setMethodDispatching(mt,NonSubsump.class);
  d3a.setMethodName(mt,"dance");
  d3a.setMethodMissingHandling(mt,Missing.IGNORE);
  f=ComboC.class.getField("self");
  d3a.setSelfField(f);
  mt=ComboC.class.getMethod("lxp",new Class[]{String.class});
  d3a.setMethodName(mt,"lxn");
  d3a.register();

  m=(Dance)PolyD.buildFromDescriptor(Dance.class,new Object[]{a,b,c,new ComboD()});
  d3a=null; //GC

  m.test(6,acme);

  m.line();
  m.visit(park);
  
  aux1.visit(park);
  
  m.line();
  
  aux1.dance(ellen,acme);
  aux1.dance(james,disco);
  aux1.dance(james,acme);
  aux1.dance(alice,disco);
  aux1.dance(alice,park);
  aux1.dance(ellen,park);
  aux1.dance(ellen,office);
  aux1.dance(james,office);

  m.line();
  
  aux2.dance(ellen,acme);
  aux2.dance(james,disco);
  aux2.dance(james,acme);
  aux2.dance(alice,disco);
  aux2.dance(alice,park);
  aux2.dance(ellen,park);
  aux2.dance(ellen,office);
  aux2.dance(james,office);

  m.line();
  m.line();
  m.line();

  m.test(6,acme);
  m.test(6,null);

  m.line();
  m.line();
  m.line();

  m.nonSubsumpDance(ellen,office);
  m.nonSubsumpDance(james,disco);
  m.nonSubsumpDance(james,acme);
  
  m.line();
  m.line();
  m.line();

  
  A aa=new A("aa");
  B bb=new B("bb");
  C cc=new C("cc");
  
  Descriptor d4=new Descriptor(I.class,new Class[] {X.class});
  d4.setDispatching(MultiDisp.class);
  mt=I.class.getMethod("testAs",new Class[]{B.class});
  d4.setMethodAsClasses(mt,new Class[]{A.class});
  d4.setMethodName(mt,"test");
  f=X.class.getField("self");
  d4.setSelfField(f);
  d4.register();

  I ii=(I)PolyD.buildFromDescriptor(I.class,new Object[]{new X()});

  ii.test(aa);
  ii.test(bb);
  ii.test(cc);
  ii.testAs(bb);


  Descriptor d5=new Descriptor(VisI.class,new Class[] {VisX.class});
  d5.setDispatching(MultiDisp.class);
  f=VisX.class.getField("self");
  d5.setSelfField(f);
  d5.registerSpecial();

  VisI ii2=(VisI)PolyD.buildSpecialFromDescriptor(VisI.class,VisX.class,new Object[]{new Integer(14)},new Class[]{int.class});

  ii2.test(aa);
  ii2.test(bb);
  ii2.test(cc);
  
 } catch(Exception e) {
  System.err.println("Something's wrong.");
  e.printStackTrace();
 }

} 
}

